// -*- C++ -*-
#ifndef __TLSERIAL_H
#define __TLSERIAL_H

#include "TLconnect.h"
#include <termios.h>


class TLSerial:public TLconnect {
private:
  // a file handle is an integer descriptor,
  Int_t fPort;
  termios* fTerm;
  Char_t *fDevice;
  Bool_t fSerOK;
public:
  TLSerial(const Int_t bufsize=1024);
  ~TLSerial();
  
  //  virtual Int_t Init(const Char_t* address,const Char_t* conffile="",bool(*setup)(void*)=NULL);
  virtual Int_t Init(const Char_t* address,const Char_t* conffile="");
  virtual Int_t Send(const Char_t* command);
  virtual Int_t Send(const Char_t* command,const Int_t length);
  virtual Int_t Receive(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t ReceiveRaw(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t Close();
  void GetChar(Char_t* c, Int_t* success, Int_t timeout=5000); // msecs  
  virtual Int_t GetPortType(){return 2;}
  static TLconnect* OpenPort(const Char_t* strport,Int_t debug);
  //  static TLconnect* OpenPort(const Char_t* strport,Int_t debug,bool(*setup)(void*)=NULL);

protected:
  virtual void Message(Int_t level, const Char_t* msg2, ...);
  virtual Int_t CheckError(const Char_t* message=0);
private:
  Int_t PutRaw(const Char_t* data,const Int_t len);

};
/*
class TLModbus:public TLSerial{
public:
  TLModbus(const Int_t bufsize=1024);
  ~TLModbus();
  virtual Int_t Send(const Char_t* command,const Int_t length);
  virtual Int_t ReceiveRaw(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t Receive(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t GetPortType(){return 5;}
protected:
  virtual void Message(const Char_t* msg1, const Char_t* msg2, ...);
};
*/

#endif //SERIAL_H
