#ifndef __TL_connect
#define __TL_connect
//////////////////////////////////////////////////////////////////////////
//                                                                      //
// TLconnect                                                            //
//                                                                      //
// parent class for device connecting                                   //
//                                                                      //
//////////////////////////////////////////////////////////////////////////


#include <stdarg.h>
#include <iostream>
#include <Rtypes.h>


class TLconnect {
 public:
  Int_t fdebug;//debug level between 0 - quiet 255 - very verbose >255 sleep time after messages
  const Char_t* fstop;//how are the commands terminated
 private:
  Char_t *fbuffer; //fbuflen
  Int_t fbuflen;


 public:
  TLconnect(const Int_t bufsize);
  virtual ~TLconnect();  

  virtual Int_t Init(const Int_t address,const Char_t* conffile="");
  //  virtual Int_t Init(const Char_t* address,const Char_t* conffile="",bool(*setup)(void*)=NULL);
  virtual Int_t Init(const Char_t* address,const Char_t* conffile="");
  virtual Int_t Send(const Char_t* command);
  virtual Int_t Send(const Char_t* command,const Int_t length);
  virtual Int_t Sendf(const Char_t* fmt, ...);
  virtual Int_t Receive(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t ReceiveRaw(void* output, const Int_t length,Int_t timeout=5000);
  virtual Int_t Receive(const Int_t length=0,Int_t timeout=5000);//into buffer
  virtual Int_t ReceiveRaw(const Int_t length,Int_t timeout=5000);//into buffer
  virtual Int_t Query(const Char_t* send, Char_t* recv, Int_t size,Int_t timeout=5000);
  virtual Int_t Query(const Char_t* send, Int_t timeout=5000);//into buffer
  virtual Bool_t sQuery(const Char_t* send, Double_t& value);
  virtual Bool_t sQuery(const Char_t* send, Int_t& value);
  virtual Bool_t sQuery(const Char_t* send, UInt_t& value);
  virtual Bool_t sQuery(const Char_t* send, Bool_t& value);
  virtual Int_t Close();

  const Char_t* GetBuffer() const;
  void ClearBuffer();
  void SetBufferSize(const Int_t bufsize);

  virtual Bool_t hasSRQ(){return false;};
  virtual Short_t IsSRQ(){return 0;};
  virtual Short_t GetSRQ(Int_t timeout){return 0;};
  virtual Bool_t hasOPC(){return false;};
  virtual Bool_t WaitOPC(Int_t timeout);
  virtual Int_t GetPortType(){return 0;};//1-gpib,2-serial,3-net,4-vxi,5-modbus

  static const Char_t* GetPortStr(const Char_t* devport);

  virtual void Message(const Char_t* msg1, const Char_t* msg2,...);
  virtual void Message(Int_t msg1, const Char_t* msg2,...);
 protected:
  virtual Int_t CheckError(const Char_t* message=0);
  virtual Int_t Configure(const Char_t* conffile);
};

#endif 
